//
//  ViewController.swift
//  DMDViewerSampleSwift
//
//  Created by Ephrem Beaino on 5/9/17.
//  Copyright © 2017 dermandar. All rights reserved.
//

import UIKit

class ViewController: UIViewController,UINavigationControllerDelegate, UIImagePickerControllerDelegate {
    var picker:UIImagePickerController? = nil;
    var aiv:UIActivityIndicatorView? = nil;
    var isSpherical:Bool = false;
    override func viewDidLoad() {
        super.viewDidLoad()
        self.picker=nil
    }
    
    func showLoadingIndicator(){
        DispatchQueue.main.async{
            if(self.aiv == nil){
                self.aiv = UIActivityIndicatorView(style: .whiteLarge)
                self.aiv?.hidesWhenStopped=true
                self.aiv?.backgroundColor=UIColor(red: 0, green: 0, blue: 0, alpha: 0.5)
                self.picker?.view.addSubview(self.aiv!)
                self.picker?.view.bringSubviewToFront(self.aiv!)
            }
            let sw:CGFloat = self.view.bounds.size.width
            let sh:CGFloat = self.view.bounds.size.height
            self.aiv?.layer.cornerRadius=25.0
            self.aiv?.layer.masksToBounds=true
            self.aiv?.frame=CGRect(x: 0, y: 0, width: 100, height: 100)
            self.aiv?.center=CGPoint(x: sw/2.0, y: sh/2.0)
            self.aiv?.startAnimating()
        }
    }
    
    func hideLoadingIndicator(){
        if(self.aiv != nil){
            self.aiv?.stopAnimating()
            self.aiv?.removeFromSuperview()
            self.aiv=nil
        }
    }
    
    
    func imagePickerController(_ picker: UIImagePickerController, didFinishPickingMediaWithInfo info: [UIImagePickerController.InfoKey : Any]) {
        showLoadingIndicator()
        DispatchQueue.main.asyncAfter(deadline: .now() + 0.1) {
            let dmdViewerCtrlr:DMDViewerController = DMDViewerController()
            dmdViewerCtrlr.modalPresentationStyle = .fullScreen
            let fovx:Int32 = 360
            if(self.isSpherical ? dmdViewerCtrlr.loadSphericalPanorama(from: info[UIImagePickerController.InfoKey.originalImage] as? UIImage) : dmdViewerCtrlr.loadPanorama(from: info[UIImagePickerController.InfoKey.originalImage] as? UIImage, fovx: fovx)){
                self.hideLoadingIndicator()
                self.presentedViewController?.present(dmdViewerCtrlr, animated: false, completion: nil)
            }else{
                NSLog("Failed to load the given image.")
            }
        }
    }
    
    
    override func viewDidAppear(_ animated: Bool) {
        super.viewDidAppear(animated)
        let ac:UIAlertController = UIAlertController(title: "Type", message: "Please select the type of panorama you want to play", preferredStyle: .actionSheet)
        ac.addAction(UIAlertAction(title: "Spherical Panorama", style: .default, handler: { (alert) in
            self.isSpherical=true
            self.picker = UIImagePickerController()
            self.picker?.delegate=self
            self.present(self.picker!, animated: false, completion: nil)
        }))
        
        ac.addAction(UIAlertAction(title: "Cylindrical Panorama", style: .default, handler: { (alert) in
            self.isSpherical=false
            self.picker = UIImagePickerController()
            self.picker?.delegate=self
            self.present(self.picker!, animated: false, completion: nil)
        }))
        
        self.present(ac, animated: true, completion: nil)
    }
    
}

